#include <stdint.h>

#include <at45.h>
#include <config.h>
#include <linux.h>
#include <pcf8833.h>
#include <sdram.h>
#include <serial.h>
#include <utils.h>
#include <xmod.h>

#define ZBOOT_SIZE		(54*AT45_PAGE_SIZE)

void zboot_start() __attribute__ ((__noreturn__));
void zboot_abort() __attribute__ ((__noreturn__));

void zboot_abort()
{
	serial_printk("\nAbort\n");
	for (;;) ;
}

void zboot_start()
{
	int lxlen;

	serial_printk("\nZBoot Started\n");

	if (sdram_test() < 0) {
		zboot_abort();
	}

	/*if (at45_init(0) < 0) {
		zboot_abort();
	}

	at45_write(0x00000000, (void*) 0x0, ZBOOT_SIZE);
	at45_read(0x00000000, (void*) SDRAM_BASE_ADDRESS, ZBOOT_SIZE);*/

	/*pcf8833_init(1, PCF8833_3R3G2B | PCF8833_MIRROR_Y);
	pcf8833_draw(0, 0, 131, 131, (void*) SDRAM_BASE_ADDRESS);*/

	lxlen = xmod_recv((void*) LINUX_BASE_ADDRESS);
	if (lxlen < 0) {
		zboot_abort();
	}

	/*pcf8833_pwoff();*/

	serial_printk("Image size: %i KB\n", (lxlen >> 10));

	linux_go();

	/*uint8_t c;
	uint8_t *ptr = (uint8_t*) SDRAM_BASE_ADDRESS;
	int i, j;
	int t = 0;
	int r;

	for (;;) {

		rval = randpw();

		for (i = 0; i < 132; ++i)
			for (j = 0; j < 132; ++j) {

				r = (i + j + t) & 127;

				if (r < 40)
					c = 0xe0;
				else if (r < 80)
					c = 0x1c;
				else if (r < 120)
					c = 0x03;
				else
					c = 0;

				*(ptr + i*132 + j) = c;
			}

		++t;

		pcf8833_draw(0, 0, 131, 131, ptr);
	}

	pcf8833_pwoff();*/

	for (;;) ;
}

